Framer.Extras.Hints.disable()
Framer.Defaults.Animation =
	curve: Spring(damping: 0.75)

# External fonts module
{Fonts} = require "Fonts"

# Load regular font
fontPath = 'fonts/Graphik-Regular.otf'
fontRegular = 'Graphik-Regular'
Fonts.add(fontPath, fontRegular)

# Load light font
fontPath = 'fonts/Graphik-Light.otf'
fontLight = 'Graphik-Light'
Fonts.add(fontPath, fontLight)

# Load italic font
fontPath = 'fonts/Graphik-LightItalic.otf'
fontLightItalic = 'Graphik-LightItalic'
Fonts.add(fontPath, fontLightItalic)

# Load bold font
fontPath = 'fonts/Graphik-Bold.otf'
fontBold = 'Graphik-Bold'
Fonts.add(fontPath, fontBold)

# App navigation
flow = new FlowComponent
flow.showNext(startView)
flow.header = statusBar

# Global vars
arcDrawOnCount = 0
startAge = 7
endAge = 97
weeks = 0

# Slider class
class LabeledSlider extends Layer
	constructor: (@options={}) ->
		@options.width ?= Screen.width - 24 - 24
		@options.height ?= 56
		@options.x ?= 24
		super @options
		
		@backgroundColor = null
		
		@.knobSize = 25
		@.listener = false
		@.currentValue = 0
		
		o = @
		
		@valueArray = []

		@sliderA = new SliderComponent
			parent: @
			name: "slider"
			backgroundColor: 'rgba(255,255,255,0.5)'
			height: 2
			width: @.width
			x: 0
			knobSize: @.knobSize
		@sliderA.fill.backgroundColor = "white"
		@sliderA.hitArea = 64
		@sliderA.y = 48
		
		# Listen for slider value updates
		@sliderA.onValueChange ->
			valIndex = o.sliderA.value * (o.valueArray.length-1)
			val = o.valueArray[Math.round(valIndex)]
			o.value.text = val
			o.currentValue = val
			if o.listener != false
				o.listener.onSliderValueChange()

		@label = new TextLayer
			parent: @
			name: "label"
			backgroundColor: null
			width: 200
			height: 24
			x: 0
			y: 0
			fontFamily: fontLightItalic
			fontSize: 16
			color: 'white'
			lineHeight: 1
			textTransform: 'uppercase'
			letterSpacing: 2
						
		@value = new TextLayer
			parent: @
			name: "value"
			backgroundColor: null
			width: 200
			height: 24
			x: Align.right(0)
			y: 0
			fontFamily: fontBold
			fontSize: 16
			color: 'white'
			lineHeight: 1
			textAlign: 'right'
			textTransform: 'uppercase'
			letterSpacing: 2
		
		@sliderA.bringToFront()
		
		
# Add the sliders
currentAgeSlider = new LabeledSlider
	parent: currentAgeView
	x: Align.center
	y: Align.center
agesArray = []
for i in [6...107]
	agesArray.push(i+1)
currentAgeSlider.valueArray = agesArray
currentAgeSlider.label.visible = false
currentAgeSlider.visible = false

currentAgeScroller = new ScrollComponent
	width: proto_age_item.width
	height: pickerContainer.height
	parent: pickerContainer
	scrollHorizontal: false
currentAgeScroller.contentInset =
	top: proto_age_item.height*3
	right: 0
	bottom: 0
	left: 0

for i in [0...100]
	n = proto_age_item.copy()
	n.x = 0
	n.y = i * proto_age_item.height
	n.text = i + 7
	n.parent = currentAgeScroller.content
proto_age_item.visible = false
picker_cover.bringToFront()
scrollPosIsFixed = false
currentAgeScroller.content.on "change:y", ->
	if Math.abs(currentAgeScroller.velocity.y) < 0.1 && scrollPosIsFixed
		scrollPosIsFixed = false
		years_label.animate
			opacity: 1.0
		currentAgeScroller.scrollToClosestLayer()
# 	for l in currentAgeScroller.content.children
# 		rY = l.midY - currentAgeScroller.scrollY
# 		if rY > 0 && rY < currentAgeScroller.height
# 			mY = currentAgeScroller.height/2
# 			percentFromCenter = rY/mY
			# TODO: Need to finish dimming method
			# using gradient cover for now
# 		else
# 			l.opacity = 0

currentAgeScroller.onScrollStart ->
	years_label.animate
		opacity: 0.2
		options: 
			time: 0.2
currentAgeScroller.onScrollEnd ->
	scrollPosIsFixed = true
currentAgeScroller.onScrollAnimationDidEnd ->
	currentAgeScroller.scrollToClosestLayer()


endAgesSlider = new LabeledSlider
	parent: endAgeView
	x: Align.center
	y: years_label.y
endAgesArray = []
for i in [55...110]
	endAgesArray.push(i+1)
endAgesSlider.valueArray = endAgesArray
endAgesSlider.label.text = "Years"
# endAgesSlider.listener = endAge

calculateEndAge = ->
	#cAge = currentAgeSlider.currentValue
	cl = currentAgeScroller.closestContentLayer(0.0, 0.0)
	cAge = Number(cl.text)
	startAge = cAge
	#update end age slider
	endAgesArray = []
	for i in [startAge...110]
		endAgesArray.push(i+1)
	endAgesSlider.label.text = cAge + 1
	endAgesSlider.label.text = "years"
	endAgesSlider.valueArray = endAgesArray
	endAgesSlider.sliderA.value = 0.75

calculateWeeks = ->
	#cAge = currentAgeSlider.currentValue
	endAge = endAgesSlider.currentValue
	years = endAge - startAge
	weeks = 52 * years


# Add the arcs
ArcLayer = require "ArcLayer"
arcWedgePercent = 0.33
arcRadius = (Screen.width - 32 - 32) / 2
arcStrokeWidth = 9

bgArc = new ArcLayer
	wedgePercent: arcWedgePercent
	radius: arcRadius
	strokeWidth: arcStrokeWidth
	color:  '#333333'
	name: "bgArc"
bgArc.x = Align.center
bgArc.y = Align.center(50)
bgArc.parent = endView

weeksLeftArc = new ArcLayer
	wedgePercent: arcWedgePercent
	radius: arcRadius
	strokeWidth: arcStrokeWidth
	color:  '#fff'
	name: "weeksLeftArc"
weeksLeftArc.x = Align.center
weeksLeftArc.y = Align.center(50)
weeksLeftArc.parent = endView





currentAgeSlider.sliderA.value = 0.25
next_2.bringToFront()

next_1.onTap ->
	flow.showNext(currentAgeView)
next_2.onTap ->
	calculateEndAge()
	flow.showNext(endAgeView)
next_3.onTap ->
	calculateWeeks()
	flow.showNext(endView)
	startEndAnimation()			
	
start_over.onTap ->
	flow.showNext(startView)


dummyLayer = new Layer
	width: 20
	height: 20
	backgroundColor: 'white'
	opacity: 0
dummyLayer.on 'change:y', ->
	onFramerAnimation()

startEndAnimation = ->
	#Reset display
	bgArc.percent = 0
	weeksLeftArc.percent = 0
	weeks_value.text = "0"
	
	percentLifeLeft = endAge/startAge
	print percentLifeLeft
	
	dummyLayer.animateStop()
	dummyLayer.y = 0
	dummyLayer.animate
		y: Screen.height
		options:
			time: 5.0
			delay: 0.3
	
onFramerAnimation = ->
	percent = dummyLayer.y / Screen.height
	
	
	bgArc.percent = percent
	weeks_value.text = Math.round(percent * weeks)


